package cn.ibizlab.businesscentral.core.scheduling.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.scheduling.domain.BookableResourceCategory;
import cn.ibizlab.businesscentral.core.scheduling.filter.BookableResourceCategorySearchContext;
import cn.ibizlab.businesscentral.core.scheduling.service.IBookableResourceCategoryService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.businesscentral.core.scheduling.mapper.BookableResourceCategoryMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[可预订资源的类别] 服务对象接口实现
 */
@Slf4j
@Service("BookableResourceCategoryServiceImpl")
public class BookableResourceCategoryServiceImpl extends ServiceImpl<BookableResourceCategoryMapper, BookableResourceCategory> implements IBookableResourceCategoryService {

    @Autowired
    @Lazy
    protected cn.ibizlab.businesscentral.core.scheduling.service.IBookableResourceCategoryAssnService bookableresourcecategoryassnService;
    @Autowired
    @Lazy
    protected cn.ibizlab.businesscentral.core.base.service.ITransactionCurrencyService transactioncurrencyService;

    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(BookableResourceCategory et) {
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getBookableresourcecategoryid()),et);
        return true;
    }

    @Override
    public void createBatch(List<BookableResourceCategory> list) {
        this.saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean update(BookableResourceCategory et) {
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("bookablerescategoryid",et.getBookableresourcecategoryid())))
            return false;
        CachedBeanCopier.copy(get(et.getBookableresourcecategoryid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<BookableResourceCategory> list) {
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public BookableResourceCategory get(String key) {
        BookableResourceCategory et = getById(key);
        if(et==null){
            et=new BookableResourceCategory();
            et.setBookableresourcecategoryid(key);
        }
        else{
        }
        return et;
    }

    @Override
    public BookableResourceCategory getDraft(BookableResourceCategory et) {
        return et;
    }

    @Override
    public boolean checkKey(BookableResourceCategory et) {
        return (!ObjectUtils.isEmpty(et.getBookableresourcecategoryid()))&&(!Objects.isNull(this.getById(et.getBookableresourcecategoryid())));
    }
    @Override
    @Transactional
    public boolean save(BookableResourceCategory et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional(
            rollbackFor = {Exception.class}
    )
    public boolean saveOrUpdate(BookableResourceCategory et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public boolean saveBatch(Collection<BookableResourceCategory> list) {
        saveOrUpdateBatch(list,batchSize);
        return true;
    }

    @Override
    public void saveBatch(List<BookableResourceCategory> list) {
        saveOrUpdateBatch(list,batchSize);
    }


	@Override
    public List<BookableResourceCategory> selectByTransactioncurrencyid(String transactioncurrencyid) {
        return baseMapper.selectByTransactioncurrencyid(transactioncurrencyid);
    }

    @Override
    public void removeByTransactioncurrencyid(String transactioncurrencyid) {
        this.remove(new QueryWrapper<BookableResourceCategory>().eq("transactioncurrencyid",transactioncurrencyid));
    }


    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<BookableResourceCategory> searchDefault(BookableResourceCategorySearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<BookableResourceCategory> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<BookableResourceCategory>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }







    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<BookableResourceCategory> getBookableresourcecategoryByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<BookableResourceCategory> getBookableresourcecategoryByEntities(List<BookableResourceCategory> entities) {
        List ids =new ArrayList();
        for(BookableResourceCategory entity : entities){
            Serializable id=entity.getBookableresourcecategoryid();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0)
           return this.listByIds(ids);
        else
           return entities;
    }

}


